/**
 * 
 */
package org.seatiger.pso;

/**
 * @author Stefan Bird <stbird@seatiger.org>
 *
 */
public class BraininRCOS implements FitnessFunction
{
   /* (non-Javadoc)
    * @see org.seatiger.pso.FitnessFunction#getNumVariables()
    */
   public int getNumVariables()
   {
      return 2;
   }

   /* (non-Javadoc)
    * @see org.seatiger.pso.FitnessFunction#getFitness(double[])
    */
   public double getFitness(double[] location)
   {
      double x = location[0];
      double y = location[1];

      double partA = y - 5 / (4 * Math.PI * Math.PI) * x * x 
            + 5 * x / Math.PI - 6;
      double partB = 10 * (1 - 1 / (8 * Math.PI)) * Math.cos(x) + 10;
      
      return -(partA * partA + partB);
   }

   /* (non-Javadoc)
    * @see org.seatiger.pso.FitnessFunction#getPreferredRanges()
    */
   public Range[] getPreferredRanges()
   {
      return new Range[] { new Range(-5, 10), new Range(0, 15) };
   }

}
