package org.seatiger.pso;

import java.util.LinkedHashSet;
import java.util.Set;

/**
 * Represents a single global neighbourhood where all of the particles
 * are connected
 * 
 * @author Stefan Bird <stbird@seatiger.org>
 */
public class GlobalNeighborhood implements Neighborhood
{
   /** The registered particles of the neighbourhood */
   LinkedHashSet<Particle> particles = new LinkedHashSet<Particle>();
   
   /**
    * @see org.seatiger.pso.Neighborhood#getNeighborhoodOf(org.seatiger.pso.Particle)
    */
   public Set<Particle> getNeighborhoodOf(Particle p)
   {
      if (particles.contains(p))
         return particles;
      else
         return null;
   }

   /**
    * @see org.seatiger.pso.Neighborhood#register(org.seatiger.pso.Particle)
    */
   public void register(Particle p)
   {
      particles.add(p);
   }

   /**
    * @see org.seatiger.pso.Neighborhood#deregister(org.seatiger.pso.Particle)
    */
   public void deregister(Particle p)
   {
      particles.remove(p);
   }

   /**
    * @see Neighborhood#deregisterAll()
    */
   public void deregisterAll()
   {
      particles.clear();
   }
}
