package org.seatiger.pso;

/**
 * This exception is thrown when two incomparable objects are compared
 * 
 * @author Stefan Bird <stbird@seatiger.org>
 */
public class InvalidComparisonException extends RuntimeException
{
   /**
    * Creates a new InvalidComparisonException without a message 
    */
   public InvalidComparisonException()
   {
      super();
   }

   /**
    * Creates a new InvalidComparisonException with the given message
    *
    * @param message A message describing the problem
    */
   public InvalidComparisonException(String message)
   {
      super(message);
   }

   /**
    * Creates a new InvalidComparisonException with the given cause
    *
    * @param cause The cause of this exception
    */
   public InvalidComparisonException(Throwable cause)
   {
      super(cause);
   }


   /**
    * Creates a new InvalidComparisonException with the given message
    * and cause
    *
    * @param message A message describing the problem
    * @param cause The cause of the exception
    */
   public InvalidComparisonException(String message, Throwable cause)
   {
      super(message, cause);
   }

}