package org.seatiger.pso;

/**
 * Thrown if a given fitness function cannot be used
 * 
 * @author Stefan Bird <stbird@seatiger.org>
 */
public class InvalidFitnessFunctionException extends RuntimeException
{
   /**
    * Creates a new IllegalOperationException without a message 
    */
   public InvalidFitnessFunctionException()
   {
      super();
   }

   /**
    * Creates a new InvalidFitnessFunction with the given message
    *
    * @param message A message describing the problem
    */
   public InvalidFitnessFunctionException(String message)
   {
      super(message);
   }

   /**
    * Creates a new InvalidFitnessFunction with the given cause
    *
    * @param cause The cause of this exception
    */
   public InvalidFitnessFunctionException(Throwable cause)
   {
      super(cause);
   }


   /**
    * Creates a new InvalidFitnessFunction with the given message
    * and cause
    *
    * @param message A message describing the problem
    * @param cause The cause of the exception
    */
   public InvalidFitnessFunctionException(String message, Throwable cause)
   {
      super(message, cause);
   }

}
