package org.seatiger.pso;

import java.util.Collection;

/**
 * Attracts a particle to a particular location
 *  
 * @author Stefan Bird <stbird@seatiger.org>
 */
public interface ParticleAttractor
{
   /**
    * Returns the attractor point
    * 
    * @param p The particle to attract
    * @param allParticles All of the particles known by the movement model
    * @return The location of the attractor point
    */
   public double[] getAttractorPoint(Particle p, Collection<Particle> allParticles);
}
