package org.seatiger.pso;

public class PolynomialSource implements RegressionSource
{
   private PolynomialRegression regression;
   
   public PolynomialSource(int order)
   {
      regression = new PolynomialRegression(order);
   }
   
   public PolynomialSource(double[] constants)
   {
      regression = new PolynomialRegression(constants.length);
      setConstants(constants);
   }

   
   
   /**
    * Sets the constants used by the polynomial
    * 
    * @param constants The constants used
    * @see org.seatiger.pso.PolynomialRegression#setConstants(double[])
    */
   public void setConstants(double[] constants)
   {
      regression.setConstants(constants);
   }

   public double calculate(double[] location)
   {
      return regression.calculate(location);
   }

   public double[][] getTestPoints()
   {
      // TODO Auto-generated method stub
      return null;
   }

}
