/**
 * 
 */
package org.seatiger.pso;

/**
 * A 2D function with 2 global optima and 4 local optima
 * 
 * @author Stefan Bird <stbird@seatiger.org>
 */
public class SixHumpCamelBack implements FitnessFunction
{

   /* (non-Javadoc)
    * @see org.seatiger.pso.FitnessFunction#getNumVariables()
    */
   public int getNumVariables()
   {
      return 2;
   }

   /* (non-Javadoc)
    * @see org.seatiger.pso.FitnessFunction#getFitness(double[])
    */
   public double getFitness(double[] location)
   {
      double x = location[0];
      double y = location[1];
      
      double partA = (4 - 2.1 * x * x + Math.pow(x, 4) / 3) * x * x;
      double partB = x * y;
      double partC = (-4 + 4 * y * y) * y * y;

      return -4 * (partA + partB + partC);
   }

   /* (non-Javadoc)
    * @see org.seatiger.pso.FitnessFunction#getPreferredRanges()
    */
   public Range[] getPreferredRanges()
   {
      return new Range[] { new Range(-1.9, 1.9), new Range(-1.1, 1.1) };
   }

}
