package org.seatiger.pso;

import java.util.EventListener;

/**
 * Lists to events generated by the Swarm class
 * 
 * @author Stefan Bird <stbird@seatiger.org>
 */
public interface SwarmListener extends EventListener
{
   /**
    * Notification that the Swarm is initialised. This notification
    * is sent at the start of the first call to {@link Swarm#step()}
    * 
    * @param e Details about the event
    */
   public void initialized(SwarmEvent e);
   
   /**
    * Notification that the Swarm has completed a step
    * 
    * @param e Details about the event
    */
   public void step(SwarmEvent e);
}
