package org.seatiger.pso;

import java.util.Collection;
import java.util.Map;

/**
 * Implements the species seed classifier using a dynamic radius. The
 * radius is calculated as the mean of the average distance between
 * each particle and its closest neighbour
 * 
 * @author Stefan Bird <stbird@seatiger.org>
 */
public class VaryingRadiusSeedClassifier extends SPSO
{
   /**
    * Creates a new VaryingRadiusSeedClassifier
    */
   public VaryingRadiusSeedClassifier()
   {
      super(0);
   }

   /* (non-Javadoc)
    * @see org.seatiger.pso.SeedSpeciesClassifier#classify(java.util.Collection)
    */
   @Override
   public Map<Particle, Integer> classify(Collection<Particle> particles)
   {
      setRadius(ANPSO.calculateAvgClosestDistance(particles));
      return super.classify(particles);
   }
}
