package org.seatiger.pso.test;

import org.seatiger.pso.*;

import junit.framework.TestCase;
import peaks.Peak_Function;

public class Peak_Function_Custom_Test extends TestCase
{
   private final static int TESTS = 100000;
   private final static int VARIABLES = 1;
   private final static int PEAKS = 1;
   
   public Peak_Function_Custom_Test(String name) 
   {
      super(name);
   } 
   
   public void testNormal()
   {
      MovingPeaks peaks = new MovingPeaks(PEAKS, VARIABLES);
      Peak_Function normal = peaks.pf;
      Peak_Function custom = new Peak_Function_Custom(1, 1, 0, 0);
      
      double minCoord = peaks.getMinCoordinate();
      double maxCoord = peaks.getMaxCoordinate();
      double range = maxCoord - minCoord;
      
      double[] testPoint = new double[VARIABLES];
      
      for (int i = 0; i < TESTS; i++)
      {     
         for (int j = 0; j < testPoint.length; j++)
            testPoint[j] = minCoord + Math.random() * range;
         
         for (int j = 0; j < PEAKS; j++)
         {
            double normalHeight = normal.calculate(testPoint, j);
            double customHeight = custom.calculate(testPoint, j);
            assertEquals(normalHeight, customHeight, 0.000001);

         }

         peaks.eval_movpeaks(testPoint);
      }
   }
}
