package org.seatiger.pso.test;

import org.seatiger.pso.PolynomialRegression;

import junit.framework.TestCase;

/**
 * Tests the PolynomialRegresion class
 * 
 * @author Stefan Bird <stbird@seatiger.org>
 */
public class PolynomialRegressionTest extends TestCase
{
   /**
    * Creates a new PolynomialRegressionTest
    */
   public PolynomialRegressionTest()
   {
      super("PolynomialRegression");
   }
   

   
   /**
    * Test method for 'org.seatiger.pso.PolynomialRegression.getNumConstants()'
    */
   public void testGetNumConstants()
   {
      PolynomialRegression polyReg = new PolynomialRegression(5);
      assertEquals(6, polyReg.getNumConstants());
   }

   /**
    * Test method for 'org.seatiger.pso.PolynomialRegression.calculate(double[])'
    */
   public void testCalculate()
   {
      PolynomialRegression polyReg = new PolynomialRegression(3);
      polyReg.setConstants(new double[] {0, 0, 0, 0});
      assertEquals(0, polyReg.calculate(new double[] {-100}), 0.00001);
      assertEquals(0, polyReg.calculate(new double[] {10}), 0.00001);
      
      polyReg.setConstants(new double[] {4, -3, 2, -1});
      assertEquals(-49, polyReg.calculate(new double[] {-2}), 0.00001);
      assertEquals(86, polyReg.calculate(new double[] {3}), 0.00001);
   }

}
