package org.seatiger.pso.test;

import java.io.IOException;
import java.io.StringReader;

import junit.framework.TestCase;

import org.seatiger.pso.*;

/**
 * Tests the RegressionEvaluator class
 * 
 * @author Stefan Bird <stbird@seatiger.org>
 */
public class RegressionEvaluatorTest extends TestCase
{
   /**
    * Creates a new RegressionEvaluatorTest
    */
   public RegressionEvaluatorTest()
   {
      super("RegressionEvaluator");
   }
   
   /**
    * Tests the regression evaluator
    * 
    * @throws IOException This should never happen...
    */
   public void testRegressionEvaluator() throws IOException
   {
      StringBuffer csv = new StringBuffer();
      csv.append("1, 1\n");
      csv.append("2, 1\n");
      csv.append("3, 1\n");
      
      CSVSource source = new CSVSource(new StringReader(csv.toString()));
      PolynomialRegression regression = new PolynomialRegression(0);
      RegressionEvaluator evaluator = 
         new RegressionEvaluator(regression, source);
      
      assertEquals(-Math.sqrt(3), evaluator.getFitness(new double[] {0}), 0.0001);
      assertEquals(0, evaluator.getFitness(new double[] {1}), 0.0001);
      assertEquals(-Math.sqrt(3), evaluator.getFitness(new double[] {2}), 0.0001);
   }
}